--- vlc/src/audio_output/intf.c	2008-12-17 23:26:44.000000000 +0800
+++ /root/intf.c	2008-12-17 22:38:57.000000000 +0800
@@ -378,15 +378,17 @@ static int aout_Restart( aout_instance_t
         return -1;
     }
 
-    /* Lock all inputs. */
-    aout_lock_input_fifos( p_aout );
-
     for ( i = 0; i < p_aout->i_nb_inputs; i++ )
     {
         aout_lock_input( p_aout, p_aout->pp_inputs[i] );
+        aout_lock_input_fifos( p_aout );
         aout_InputDelete( p_aout, p_aout->pp_inputs[i] );
+        aout_unlock_input_fifos( p_aout );
     }
 
+    /* Lock all inputs. */
+    aout_lock_input_fifos( p_aout );
+
     aout_MixerDelete( p_aout );
 
     /* Re-open the output plug-in. */
@@ -395,11 +397,11 @@ static int aout_Restart( aout_instance_t
     if ( aout_OutputNew( p_aout, &p_aout->pp_inputs[0]->input ) == -1 )
     {
         /* Release all locks and report the error. */
+        aout_unlock_input_fifos( p_aout );
         for ( i = 0; i < p_aout->i_nb_inputs; i++ )
         {
             vlc_mutex_unlock( &p_aout->pp_inputs[i]->lock );
         }
-        aout_unlock_input_fifos( p_aout );
         aout_unlock_mixer( p_aout );
         return -1;
     }
@@ -407,25 +409,27 @@ static int aout_Restart( aout_instance_t
     if ( aout_MixerNew( p_aout ) == -1 )
     {
         aout_OutputDelete( p_aout );
+        aout_unlock_input_fifos( p_aout );
         for ( i = 0; i < p_aout->i_nb_inputs; i++ )
         {
             vlc_mutex_unlock( &p_aout->pp_inputs[i]->lock );
         }
-        aout_unlock_input_fifos( p_aout );
         aout_unlock_mixer( p_aout );
         return -1;
     }
 
+    aout_unlock_input_fifos( p_aout );
     /* Re-open all inputs. */
     for ( i = 0; i < p_aout->i_nb_inputs; i++ )
     {
+        aout_lock_input_fifos( p_aout );
         aout_input_t * p_input = p_aout->pp_inputs[i];
         b_error |= aout_InputNew( p_aout, p_input, &p_input->request_vout );
         p_input->b_changed = 1;
+        aout_unlock_input_fifos( p_aout );
         aout_unlock_input( p_aout, p_input );
     }
 
-    aout_unlock_input_fifos( p_aout );
     aout_unlock_mixer( p_aout );
 
     return b_error;
